//File To See If Mouse Pressed A Button
//I found out the mouse used a 640 x 480 mouse res in mode 13h
//Linke with mousecpp.obj

#include <stdio.h>
#include "mouse.h"

//Video Buffer Memory
char far *video_buffer=(char far *)0xA0000000;

void Draw_Box(int x1,int y1,int x2,int y2,int color)
{
    int width=x2-x1;
    int height=y2-y1;
    _asm
    {
        ;Save Data Segment Register
        push ds
        ;Get Pointer For Video Buffer On Destination SEGMENT
        les di,video_buffer
        ;Get Starting Position Using Shifting
        mov ax,y1
        mov bx,ax
        shl ax,8
        shl bx,6
        add ax,bx
        add ax,x1
        add di,ax
        ;Code For Y Loop
        mov cx,height
        Y_LOOP:
        ;Exchang Registers CX and DX so we preserve CX but get an extra cx
        xchg cx,dx
        ;Set Color In Al
        mov al,BYTE PTR color
        ;Put width in CX so rep stosb can draw right number of bytes
        mov cx,width
        ;Draw Scanline
        rep stosb
        ;Move Offset To Next Scanline
        ;Remember rep stosb added width bytes to the offset so we
        ;Have to subtract them back from the offset
        add di,320
        sub di,width
        ;Restore Y loop value to CX
        xchg cx,dx
        ;repeat for height times
        loop Y_LOOP
        ;Restore Data Segment Register
        pop ds
    }
}

int main()
{
   //Test Variable to see if pressed exit button.
   //Is One If We Exit
   char doexit=0;
   //Mouse X and Y
   int mousex=0,mousey=0;
   //Mouse Buttons
   int mouseb=0;
   //Set The Video Mode To 13h
   _asm
   {
       mov ax,0013h
       int 10h
   }
   //Reset Mouse
   Squeeze_Mouse(MOUSE_RESET);
   //Draw Graphics Before We Show The Mouse!
   //Draw Shadow For Test Box
   Draw_Box(152,92,172,112,2);
   //Draw Our Test Box
   Draw_Box(150,90,170,110,10);
   //Show Mouse
   Squeeze_Mouse(MOUSE_SHOW);
   while (!doexit)
   {
       //Get Mouse Positions And State Of Buttons
       Squeeze_Mouse(MOUSE_BUTT_POS);
       mousex=xmouse/2;
       mousey=ymouse;
       mouseb=bmouse;
       //If Left Mouse Button Is Pressed On Exit Button Then Exit
       if ((mousex>=150)&&(mousex<=170)&&(mousey>=90)&&(mousey<=110)&&(mouseb&MOUSE_LEFT_BUTTON))
       {
           //Set Variable To Exit
           doexit=1;
       }       
   }
   //Hide Mouse
   Squeeze_Mouse(MOUSE_HIDE);
   //Return Video Mode To Text Mode
   _asm
   {
       mov ax,03h
       int 10h
   }
   //Return 0
   //Note: We Do not need to but do it just to be safe
   return 0;
}