
// I N C L U D E S ///////////////////////////////////////////////////////////

#include <dos.h>
#include <bios.h>
#include <stdio.h>
#include <math.h>
#include <conio.h>
#include <graph.h>
#include "mouse.h"

int xmouse,ymouse,bmouse;

int Squeeze_Mouse(int command)
{
// mouse interface, we'll use _int86 instead of inline asm...Why? No real reason.
// what function is caller requesting?

int returnv;

switch(command)
      {

      case MOUSE_RESET:
           {
           _asm
           {
               mov ax,0
               int 33h
               mov bmouse,bx
               mov returnv,ax
           }
           return returnv;
           } break;

      case MOUSE_SHOW:
           {
           // this function increments the internal show mouse counter.
           // when it is equal to 0 then the mouse will be displayed.
           _asm
           {
               mov ax,1
               int 33h
               mov returnv,1
           }
           return returnv;
           } break;

      case MOUSE_HIDE:
           {
           // this function decrements the internal show mouse counter.
           // when it is equal to -1 then the mouse will be hidden.
           _asm
           {
               mov ax,2
               int 33h
               mov returnv,1
           }
           return returnv;
           } break;

      case MOUSE_BUTT_POS:
           {
           // this functions gets the buttons and returns the absolute mouse
           // positions in the vars x,y, and buttons, respectively
           _asm
           {
               mov ax,3
               int 33h
               mov xmouse,cx
               mov ymouse,dx
               mov bmouse,bx
               mov returnv,1
           }
           return returnv;
           } break;

      case MOUSE_MOTION_REL:
           {
           // this functions gets the relative mouse motions from the last
           // call and puts them in the vars x,y respectively
           _asm
           {
               mov ax,0Bh
               int 33h
               mov xmouse,cx
               mov ymouse,dx
               mov returnv,1
           }
           return returnv;
           } break;

      case MOUSE_SET_SENSITIVITY:
           {
           // this function sets the overall "sensitivity" of the mouse.
           // each axis can have a sensitivity from 1-100.  So the caller
           // should put 1-100 in both "x" and "y" before calling/
           // also "buttons" is used to send in the doublespeed value which
           // ranges from 1-100 also.
           _asm
           {       
               mov bx,xmouse
               mov cx,ymouse
               mov dx,1Ah
               mov ax,2
               int 33h
               mov returnv,1
           }
           return returnv;
           } break;

      default:break;

      } // end switch
      return 0;

} // end Squeze_Mouse

//////////////////////////////////////////////////////////////////////////////

